#!/usr/bin/env node

const bin = require('.')
const path = require('path')
const fs = require('fs-extra')

const install = (mods, argv) => mods.reduce((p, pkg) =>
  p.then(() => bin(Object.assign({}, argv, pkg))), Promise.resolve())

const yargs = require('yargs') // eslint-disable-line
  .command('install', '安装全部依赖', ({ argv }) => {
    const file = path.join(process.cwd(), 'package.json')
    const pack = require(file)
    pack.binDependencies = pack.binDependencies || {}
    console.log('正在安装二进制依赖... 请稍等~')
    const mods = argv._.map(name => name.split('@'))
      .filter(name => name.length === 2)
      .map(([name, version]) => ({ name, version }))
    if (mods.length) {
      install(mods, argv)
        .then(() => (pack.binDependencies = Object.assign(
          pack.binDependencies,
          mods.reduce((p, { name, version }) => (p[name] = version) && p, {})
        )))
        .then(() => fs.writeJson(file, pack, { spaces: 2 }))
        .then(() => console.log(mods.length + ' 个模块已安装完成'))
        .catch(console.error)
    } else {
      const mods = Object
        .entries(pack.binDependencies)
        .map(([name, version]) => ({ name, version }))
      install(mods, argv)
        .then(() => console.log(mods.length + ' 个模块已安装完成'))
        .catch(console.error)
    }
  })
  .argv
